@article{hopcroft2006automata,
  title={Automata theory, languages, and computation},
  author={Hopcroft, John E and Motwani, Rajeev and Ullman, Jeffrey D},
  journal={International Edition},
  volume={24},
  number={2},
  pages={171--183},
  year={2006}
}
